//***********************************************
//*                 Main.C                      *
//***********************************************
//* W402 MPLAB C18 Advance Workshop          *
//* Written by: Richard Yang                    *
//*             Sr. Corporate Applications Engr.*
//*             Microchip Technology Inc.       *
//* Date:       12/26 2012                 *
//* Revision:	2                               *
//***********************************************
//*                               mߤ@	
//* 1. N W402 C Workshop rq ROM ŪXܦb LCD ùĤ@m
//* 2. NA^WrܦbĤG檺_lm
//* 3. N@ƥئrq 0  9 ܦb LCD ĤG̫@ӦmAɶ 0.5 Sec
//* 4. NA{g즳ݸ渹(//?)
	
//*           ŧiҨϥΪtJ
//***********************************************************
#include <p18cxxx.h>
#include <delays.h>
#include "P18F_LCD.h"

//*           ƭ쫬ŧi
//***********************************************************
void InitializePORT(void);

//********** Set the Basic Configuration Bits   *********
// OSC used the Internal RC 8MHz, Disable Watch-Dog Timer, Enable Brown-out Reset, Brown-out level = 4.3V,
// Disable Low-voltage Programming, Disable AD input on PORTB, Disable Extented Instruction Set, Enable MCLR Reset
#pragma config OSC=INTIO7, WDT=OFF, BOREN = ON, BORV = 1, LVP=OFF, PBADEN=OFF, XINST = OFF, MCLRE = ON

//*           wqdrܼƨéb Access Bank          
//*********************************************************** 

char LCD_RAM_MSG[ ]="Richard Yang";
unsigned char LCD_Char='0';


//*           wqLCDܪdréb ROM      
//*********************************************************** 
#pragma romdata RomData
const rom char LCD_ROM_MSG[ ] ="W402 C Workshop";
#pragma code


//***********************************************************
/*														   */
/* 						Main 	Program					   */
/*														   */
//***********************************************************
void main(void)
{
	OSCCONbits.IRCF = 0x07 ;		// 	Select INTOSC-8Mhz as clock source
									// 	ToDo : iHվ IRCF 줸ӳ]wu@Wv 
	ADCON1bits.PCFG = 0x0f ;		//	Set all ADC multiplexed pins as digital mode

	InitializePORT( );

//*************************************************
//*             mߤ@@XLCD
//*  1. } LCD Ҳ
//*  2. b LCD Ĥ@ܦrT"W402 C Workshop"
//*  3. b LCD ĤGܧA^Wr
//*
//*  A|Ψ LCD }Ҩ禡BLCD  Cursor m禡
//*  d@UiHe ROM r RAM rꪺ LCD 禡
//*************************************************
//??? T{ng

//???			// } LCD Ҳ
//???			// b LCD Ĥ@ܦrT"W402 C Workshop"
//???			// ]wЦ}Ab LCD ĤGܧA^WrA
			putsLCD(LCD_RAM_MSG) ;

	while(1)
	{

//*************************************************************
//*             mߤG@XLCD
//* 1. ]wܦmbĤG15ӡAܤ@ƥئr(0~9)j0.5
//* 2. ϥΩƥ Delay10KTCYx(unsigned char)ӧ (8MHz OSC)
//* 3. Q putcLCD( ) ܼƦrb LCD WAdq"0x30" to "0x39"	
//*************************************************************
// ??? {ng
		// 10K Tcy is around 1ms when running @ 40Mhz
		// So, around 5ms when running @ 8Mhz 
		Delay10KTCYx(99);
		LCD_Set_Cursor(1,15);
//???	putcLCD(???) ;  //Q putcLCD( ) ܼƦrb LCD W
//???	if (LCD_Char==???) LCD_Char=???;  // dq"0x30" to "0x39"
	}

}



//************************************************
//*        Function: Initialize PORT             *
//************************************************
void InitializePORT(void)
{

	PORTA=0x00100000;			// RA5 is hi to disable SPI EEPROM if used.
	TRISA=0b11011011;			// RA2 as LCD-E control, RA5 as CS Control for SPI
		
	PORTD=0x00;
	TRISD=0x00;					// Set PORTD as Output port
}
							
#pragma code
